import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.12

import org.kde.kirigami 2.3 as Kirigami

Kirigami.ApplicationWindow {
    visible: true
    width: 480
    height: 360
    title: qsTr("dnssdviewer")

    ScrollView {
        anchors.fill: parent
        Kirigami.FormLayout {

            Kirigami.Separator {
                Kirigami.FormData.label: "Service Details"
                Kirigami.FormData.isSection: true
            }

            Label {
                Kirigami.FormData.label: "domain"
                text: service.domain
            }

            Label {
                Kirigami.FormData.label: "hostName"
                text: service.hostName
            }

            Label {
                Kirigami.FormData.label: "port"
                text: service.port
            }

            Label {
                Kirigami.FormData.label: "serviceName"
                text: service.serviceName
            }

            Label {
                Kirigami.FormData.label: "type"
                text: service.type
            }

            Kirigami.Separator {
                Kirigami.FormData.label: "Service Specific Data"
                Kirigami.FormData.isSection: true
            }

            Repeater {
                model: service.textData

                Label {
                    Kirigami.FormData.label: modelData.key
                    text: modelData.value
                }
            }
        }
        width: parent.width
    }
}
