import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.12

import org.kde.kirigami 2.3 as Kirigami

import org.kde.upnpviewer.private 1.0

Kirigami.ApplicationWindow {
    visible: true
    width: 480
    height: 360
    title: qsTr("upnpviewer")

    UpnpDiscoverer { id: disc }

    ScrollView {
        anchors.fill: parent

        ListView {
            width: parent.width
            model: disc.devices
            delegate: Kirigami.BasicListItem {
                RowLayout {
                    Kirigami.FormLayout {

                        //                    STRING_PROP(udn)
                        //                    STRING_PROP(friendly_name)
                        //                    STRING_PROP(manufacturer)
                        //                    STRING_PROP(manufacturer_url)
                        //                    STRING_PROP(model_name)
                        //                    STRING_PROP(model_number)
                        //                    STRING_PROP(model_url)
                        //                    STRING_PROP(presentation_url)
                        //                    STRING_PROP(serial_number)

                        Kirigami.Separator {
                            Kirigami.FormData.label: "Device Details"
                            Kirigami.FormData.isSection: true
                        }

                        Label {
                            Kirigami.FormData.label: "friendly_name"
                            text: modelData.friendly_name
                        }

                        Label {
                            Kirigami.FormData.label: "manufacturer"
                            text: modelData.manufacturer
                        }

                        Label {
                            Kirigami.FormData.label: "manufacturer_url"
                            text: modelData.manufacturer_url
                        }

                        Label {
                            Kirigami.FormData.label: "model_name"
                            text: modelData.model_name
                        }

                        Label {
                            Kirigami.FormData.label: "model_number"
                            text: modelData.model_number
                        }

                        Label {
                            Kirigami.FormData.label: "model_url"
                            text: modelData.model_url
                        }

                        Label {
                            Kirigami.FormData.label: "presentation_url"
                            text: modelData.presentation_url
                        }

                        Kirigami.Separator {
                            Kirigami.FormData.label: "Robot Details"
                            Kirigami.FormData.isSection: true
                        }

                        Label {
                            Kirigami.FormData.label: "serial_number"
                            text: modelData.serial_number
                        }

                        Label {
                            Kirigami.FormData.label: "udn"
                            text: modelData.udn
                        }

                        Kirigami.Separator {
                            Kirigami.FormData.label: "Debug"
                            Kirigami.FormData.isSection: true
                        }

                        Label {
                            Kirigami.FormData.label: "location"
                            text: modelData.location
                        }

                        Label {
                            Kirigami.FormData.label: "model_description"
                            text: modelData.model_description
                        }

                        Label {
                            Kirigami.FormData.label: "device_type"
                            text: modelData.device_type
                        }
                    }
                    width: parent.width
                }
            }
        }
    }
}
